/*
 * This file is part of ArmarX.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @package    ...
 * @author     Jianfeng Gao ( jianfeng dot gao at kit dot edu )
 * @date       2021
 * @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *             GNU General Public License
 */

#pragma once

#include <RobotAPI/interface/units/RobotUnit/NJointController.ice>
#include <RobotAPI/interface/core/Trajectory.ice>
#include <RobotAPI/interface/aron.ice>

#include <ArmarXCore/interface/serialization/Eigen.ice>

#include <armarx/control/interface/ConfigurableNJointControllerInterface.ice>


module armarx{ module control{
    interface NJointTaskspaceImpedanceControllerInterface extends ConfigurableNJointControllerInterface
    {
        //        string getKinematicChainName();
        Ice::FloatSeq getTCPVel();
    };

    interface NJointTaskspaceAdmittanceControllerInterface extends ConfigurableNJointControllerInterface
    {
        //        string getKinematicChainName();

        /// ft sensor
        void toggleGravityCompensation(bool toggle);
        void calibrateFTSensor();
    };

//    interface NJointTaskspaceBimanualImpedanceControllerInterface extends ConfigurableNJointControllerInterface
//    {
//    };

    interface NJointKeypointsImpedanceControllerInterface extends ConfigurableNJointControllerInterface
    {
        //        string getKinematicChainName();
    };

};  /// control
};  /// armarx
