#include "RelaxHand.h"

namespace armarx::control::skills::skills
{
    RelaxHand::RelaxHand(const HandUnitRemote& r) :
        ::armarx::skills::SimpleSpecializedSkill<RelaxHandParams>(GetSkillDescription()), remote(r)
    {
    }

    armarx::skills::Skill::MainResult
    RelaxHand::main(const SpecializedMainInput& in)
    {
        HandUnitInterfacePrx& handUnit = remote.getHandUnit(in.parameters.hand);

        ARMARX_INFO << "Setting shape of hand '" << handUnit->getHandName() << "' to 'Relax'.";
        handUnit->setShape("Relax");
        return MakeSucceededResult();
    }

} // namespace armarx::control::skills::skills
